Public Class frmSafecracker
  Dim Combo(4) As Label
  Dim ComboButton(9) As Button
  Dim NumberDigits As Integer
  Dim SecretCombo As String
  Dim DigitsEntered As Integer
  Dim EnteredCombo As String
  Dim WrongSound As System.Media.SoundPlayer
  Dim CorrectSound As System.Media.SoundPlayer
  Dim MyRandom As New Random



  Private Sub frmSafecracker_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    'disable combination panel and setup arrays
    pnlSafe.Enabled = False
    Combo(1) = lblCombo1
    Combo(2) = lblCombo2
    Combo(3) = lblCombo3
    Combo(4) = lblCombo4
    ComboButton(1) = btn1
    ComboButton(2) = btn2
    ComboButton(3) = btn3
    ComboButton(4) = btn4
    ComboButton(5) = btn5
    ComboButton(6) = btn6
    ComboButton(7) = btn7
    ComboButton(8) = btn8
    ComboButton(9) = btn9
    WrongSound = New System.Media.SoundPlayer(Application.StartupPath + "\uhoh.wav")
    CorrectSound = New System.Media.SoundPlayer(Application.StartupPath + "\tada.wav")
  End Sub

  Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
    Me.Close()
  End Sub

  Private Sub btnStartStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStartStop.Click
    Dim I As Integer, J As Integer, K As Integer
    Dim UniqueDigit As Boolean
    If btnStartStop.Text = "Start Game" Then
      btnStartStop.Text = "Stop Game"
      grpOptions.Enabled = False
      btnExit.Enabled = False
      pnlSafe.Enabled = True
      txtResults.Text = ""
      'determine number of digits and set up labels
      If rdoTwoDigits.Checked Then
        NumberDigits = 2
      ElseIf rdoThreeDigits.Checked Then
        NumberDigits = 3
      Else
        NumberDigits = 4
      End If
      For I = 1 To NumberDigits
        Combo(I).Visible = True
        Combo(I).Text = ""
      Next
      If NumberDigits <> 4 Then
        For I = NumberDigits + 1 To 4
          Combo(I).Visible = False
        Next
      End If
      'determine combination
      SecretCombo = ""
      For I = 1 To NumberDigits
        'select unique digit
        Do
          J = MyRandom.Next(9) + 1
          UniqueDigit = True
          If I <> 1 Then
            For K = 1 To I - 1
              If Val(Mid(SecretCombo, K, 1)) = J Then
                UniqueDigit = False
              End If
            Next
          End If
        Loop Until UniqueDigit
        SecretCombo += J.ToString()
      Next
      EnteredCombo = ""
      DigitsEntered = 0
    Else
      If EnteredCombo = SecretCombo Then
        txtResults.AppendText("That's it!!" + ControlChars.CrLf)
      Else
        txtResults.AppendText("Game Stopped" + ControlChars.CrLf)
      End If
      txtResults.AppendText("Combination: " + SecretCombo)
      btnStartStop.Text = "Start Game"
      grpOptions.Enabled = True
      btnExit.Enabled = True
      pnlSafe.Enabled = False
    End If
  End Sub

  Private Sub btnCombo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn1.Click, btn9.Click, btn8.Click, btn7.Click, btn6.Click, btn5.Click, btn4.Click, btn3.Click, btn2.Click
    Dim I As Integer, J As Integer
    Dim N As String
    Dim NumberRight As Integer, PositionRight As Integer
    'determine which button was clicked
    Dim ClickedButton As Button
    ClickedButton = CType(sender, Button)
    'last element of name is button number
    N = ClickedButton.Text
    'disable button since digits can't repeat
    ClickedButton.Enabled = False
    'if first button in combo, clear out label boxes
    If DigitsEntered = 0 Then
      Combo(1).Text = ""
      Combo(2).Text = ""
      Combo(3).Text = ""
      Combo(4).Text = ""
    End If
    'add button to code
    EnteredCombo += N
    DigitsEntered += 1
    Combo(DigitsEntered).Text = N
    'if all digits entered, check combo
    If DigitsEntered = NumberDigits Then
      'reset combo buttons
      For I = 1 To 9
        ComboButton(I).Enabled = True
      Next
      'check combination
      txtResults.AppendText("Entered: " + EnteredCombo + ControlChars.CrLf)
      If EnteredCombo = SecretCombo Then
        CorrectSound.Play()
        btnStartStop.PerformClick()
      Else
        WrongSound.Play()
        NumberRight = 0
        For I = 1 To NumberDigits
          N = Mid(EnteredCombo, I, 1)
          For J = 1 To NumberDigits
            If N = Mid(SecretCombo, J, 1) Then
              NumberRight += 1
            End If
          Next
        Next
        'how many in correct position
        PositionRight = 0
        For I = 1 To NumberDigits
          If Mid(SecretCombo, I, 1) = Mid(EnteredCombo, I, 1) Then
            PositionRight += 1
          End If
        Next
        txtResults.AppendText(NumberRight.ToString() + " digits correct" + ControlChars.CrLf)
        txtResults.AppendText(PositionRight.ToString() + " in correct position" + ControlChars.CrLf)
        txtResults.AppendText("Try again ..." + ControlChars.CrLf + ControlChars.CrLf)
        'clear combo to try again
        EnteredCombo = ""
        DigitsEntered = 0
      End If
    End If
  End Sub

  
End Class
